package unicrawler.downloader;

import java.io.IOException;
import java.net.HttpURLConnection;

import org.apache.log4j.Logger;

import unicrawler.CrawlerEnvironment;
import unicrawler.types.CrawlerURL;
import unicrawler.types.Page;

public class WebpageDownloader {

	private CrawlerEnvironment mEnvironment;
	private Logger logger = Logger.getLogger(WebpageDownloader.class.getName());
	
	public WebpageDownloader(CrawlerEnvironment _env) {
		this.mEnvironment = _env;
	}
	
	/*
	 * TODO: refactor, have interface to support different types of downloaders
	 * 			ABSTRACTION!
	 */
	public Page downloadPage(CrawlerURL _url) {
		HttpURLConnection conn = null;
		byte[] content = null;
		int respCode = 0;
		long startTime = 0;
		long respTime = 0;
		
		// refactor, this is ugly. minimalistic implementation
		// need support for charsets, redirects, response code error handling, headers such as content-length, cookies? etc
		startTime = System.currentTimeMillis();
		
		try {

			// Setup our connection
			conn = (HttpURLConnection)_url.getAsObject().openConnection();
			// TODO: set timeouts? Deal with headers sent from server? Content-type?
			conn.setRequestProperty("User-Agent", this.mEnvironment.getProperties().get("downloader.useragent"));
			conn.setRequestProperty("Pragma", "no-cache");
			conn.setRequestProperty("Cache-control", "no-cache");
			conn.setRequestMethod("GET");
			conn.connect();

			respCode = conn.getResponseCode();

			// TODO: check character encoding... foreign languages etc
			content = org.apache.commons.io.IOUtils.toByteArray(conn.getInputStream());
		}
		catch (IOException ex) {

		}
		catch (Exception ex) {
			logger.error(ex);
		}
		finally {
			conn.disconnect();
		}
		
		respTime = System.currentTimeMillis() - startTime;
		
		return new Page(_url, content, respCode, respTime);
	}
}
